define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'zz/index' + location.search,
                    add_url: 'zz/add',
                    edit_url: 'zz/edit',
                    del_url: 'zz/del',
                    multi_url: 'zz/multi',
                    import_url: 'zz/import',
                    table: 'zz',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'boxid', title: __('Boxid')},
                        {field: 'boxgoods', title: __('Boxgoods'), operate: 'LIKE'},
                        {field: 'zzuser', title: __('Zzuser'), operate: 'LIKE'},
                        {field: 'szuser', title: __('Szuser'), operate: 'LIKE'},
                        {field: 'zhuanztime', title: __('Zhuanztime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'zzid', title: __('Zzid')},
                        {field: 'zzimage', title: __('Zzimage'), operate: false, events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});